<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>LibraryMgr: models/Article/Book/Book.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="logo_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">LibraryMgr
   &#160;<span id="projectnumber">0.4</span>
   </div>
   <div id="projectbrief">Library manager desktop app</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_book_8h_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Book.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#ifndef LIBRARYMGR_BOOK_H</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#define LIBRARYMGR_BOOK_H</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;ostream&gt;</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#include &quot;../Item/Item.h&quot;</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;</div><div class="line"><a name="l00028"></a><span class="lineno"><a class="line" href="class_book.html">   28</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_book.html">Book</a> : <span class="keyword">public</span> <a class="code" href="class_item.html">Item</a> {</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    <span class="comment">// constructors</span></div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    <a class="code" href="class_book.html#abef10101f474f12e17fc49a6eeb5b307">Book</a>(</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;            <span class="keyword">const</span> std::string isbnCode,</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;            std::string title,</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;            std::string description,</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;            <span class="keywordtype">bool</span> isAvailable = <span class="keyword">true</span>,</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;            <span class="keywordtype">bool</span> isBooked = <span class="keyword">false</span></div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    );</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    <a class="code" href="class_book.html#abef10101f474f12e17fc49a6eeb5b307">Book</a>(<span class="keyword">const</span> std::string isbnCode);</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    <a class="code" href="class_book.html#abef10101f474f12e17fc49a6eeb5b307">Book</a>(<span class="keyword">const</span> <a class="code" href="class_book.html">Book</a> &amp;b);</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    <span class="comment">// setters</span></div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_book.html#a7fcc6a13174d31ae9d6789beffbdae60">makeUnAvailableToUsers</a>();</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_book.html#ac15d2bf0a6b21e9d6996540b1a6242e0">makeAvailableToUsers</a>();</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="class_book.html#a8b19e4877f1e57bc513b5025f983fbe5">returnToLibrary</a>();</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="class_book.html#a05a872fe6ae841704f27e370e31d1901">reserve</a>();</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    <span class="comment">// getters</span></div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="class_book.html#a4cdc9d69b29066a22c3dbfdd902b4d81">isAvailableToUsers</a>() <span class="keyword">const</span>;</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="class_book.html#a3ae9e7c3540adf5d0bb3f2b38f3484fb">isBookedByUser</a>() <span class="keyword">const</span>;</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;    <span class="comment">// operators</span></div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    <a class="code" href="class_book.html">Book</a> &amp;<a class="code" href="class_book.html#a26a6c2ae89938f76269e2f93e7ee676f">operator=</a>(<span class="keyword">const</span> <a class="code" href="class_book.html">Book</a> &amp;b);</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="class_book.html#ab08c02fc82b5c2f9b9a9bef03063598f">operator==</a>(<span class="keyword">const</span> <a class="code" href="class_book.html">Book</a> &amp;other) <span class="keyword">const</span>;</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="class_book.html#a77903c7af788afd234d6cf3f64a02541">operator!=</a>(<span class="keyword">const</span> <a class="code" href="class_book.html">Book</a> &amp;other) <span class="keyword">const</span>;</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;    <span class="keyword">friend</span> std::ostream &amp;<a class="code" href="class_book.html#ae8c42bdbe7ea5ce5e0c4234fc3041f59">operator&lt;&lt;</a>(std::ostream &amp;out, <span class="keyword">const</span> <a class="code" href="class_book.html">Book</a> &amp;book);</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;    <span class="keywordtype">bool</span> isAvailable;  <span class="comment">// can users view it</span></div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;    <span class="keywordtype">bool</span> isBooked;  <span class="comment">// is booked by other user</span></div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;};</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;<span class="preprocessor">#endif // LIBRARYMGR_BOOK_H</span></div><div class="ttc" id="class_book_html"><div class="ttname"><a href="class_book.html">Book</a></div><div class="ttdoc">Library book with author, ISBN and status. </div><div class="ttdef"><b>Definition:</b> Book.h:28</div></div>
<div class="ttc" id="class_book_html_a26a6c2ae89938f76269e2f93e7ee676f"><div class="ttname"><a href="class_book.html#a26a6c2ae89938f76269e2f93e7ee676f">Book::operator=</a></div><div class="ttdeci">Book &amp; operator=(const Book &amp;b)</div><div class="ttdoc">operator = Book deep copy of person </div><div class="ttdef"><b>Definition:</b> Book.cpp:31</div></div>
<div class="ttc" id="class_book_html_a4cdc9d69b29066a22c3dbfdd902b4d81"><div class="ttname"><a href="class_book.html#a4cdc9d69b29066a22c3dbfdd902b4d81">Book::isAvailableToUsers</a></div><div class="ttdeci">bool isAvailableToUsers() const </div><div class="ttdoc">find if this book is available to users </div><div class="ttdef"><b>Definition:</b> Book.cpp:83</div></div>
<div class="ttc" id="class_item_html"><div class="ttname"><a href="class_item.html">Item</a></div><div class="ttdoc">general item to buy with ID </div><div class="ttdef"><b>Definition:</b> Item.h:27</div></div>
<div class="ttc" id="class_book_html_a05a872fe6ae841704f27e370e31d1901"><div class="ttname"><a href="class_book.html#a05a872fe6ae841704f27e370e31d1901">Book::reserve</a></div><div class="ttdeci">bool reserve()</div><div class="ttdef"><b>Definition:</b> Book.cpp:74</div></div>
<div class="ttc" id="class_book_html_a3ae9e7c3540adf5d0bb3f2b38f3484fb"><div class="ttname"><a href="class_book.html#a3ae9e7c3540adf5d0bb3f2b38f3484fb">Book::isBookedByUser</a></div><div class="ttdeci">bool isBookedByUser() const </div><div class="ttdoc">find if this book is bookable by users </div><div class="ttdef"><b>Definition:</b> Book.cpp:87</div></div>
<div class="ttc" id="class_book_html_a77903c7af788afd234d6cf3f64a02541"><div class="ttname"><a href="class_book.html#a77903c7af788afd234d6cf3f64a02541">Book::operator!=</a></div><div class="ttdeci">bool operator!=(const Book &amp;other) const </div><div class="ttdoc">compare with other object </div><div class="ttdef"><b>Definition:</b> Book.cpp:57</div></div>
<div class="ttc" id="class_book_html_ab08c02fc82b5c2f9b9a9bef03063598f"><div class="ttname"><a href="class_book.html#ab08c02fc82b5c2f9b9a9bef03063598f">Book::operator==</a></div><div class="ttdeci">bool operator==(const Book &amp;other) const </div><div class="ttdoc">equals other item </div><div class="ttdef"><b>Definition:</b> Book.cpp:53</div></div>
<div class="ttc" id="class_book_html_ae8c42bdbe7ea5ce5e0c4234fc3041f59"><div class="ttname"><a href="class_book.html#ae8c42bdbe7ea5ce5e0c4234fc3041f59">Book::operator&lt;&lt;</a></div><div class="ttdeci">friend std::ostream &amp; operator&lt;&lt;(std::ostream &amp;out, const Book &amp;book)</div><div class="ttdoc">operator &lt;&lt; printer </div><div class="ttdef"><b>Definition:</b> Book.cpp:91</div></div>
<div class="ttc" id="class_book_html_a8b19e4877f1e57bc513b5025f983fbe5"><div class="ttname"><a href="class_book.html#a8b19e4877f1e57bc513b5025f983fbe5">Book::returnToLibrary</a></div><div class="ttdeci">bool returnToLibrary()</div><div class="ttdef"><b>Definition:</b> Book.cpp:69</div></div>
<div class="ttc" id="class_book_html_abef10101f474f12e17fc49a6eeb5b307"><div class="ttname"><a href="class_book.html#abef10101f474f12e17fc49a6eeb5b307">Book::Book</a></div><div class="ttdeci">Book(const std::string isbnCode, std::string title, std::string description, bool isAvailable=true, bool isBooked=false)</div><div class="ttdoc">Book new library book with initial status. </div><div class="ttdef"><b>Definition:</b> Book.cpp:22</div></div>
<div class="ttc" id="class_book_html_ac15d2bf0a6b21e9d6996540b1a6242e0"><div class="ttname"><a href="class_book.html#ac15d2bf0a6b21e9d6996540b1a6242e0">Book::makeAvailableToUsers</a></div><div class="ttdeci">void makeAvailableToUsers()</div><div class="ttdoc">makes this book available to library users </div><div class="ttdef"><b>Definition:</b> Book.cpp:65</div></div>
<div class="ttc" id="class_book_html_a7fcc6a13174d31ae9d6789beffbdae60"><div class="ttname"><a href="class_book.html#a7fcc6a13174d31ae9d6789beffbdae60">Book::makeUnAvailableToUsers</a></div><div class="ttdeci">void makeUnAvailableToUsers()</div><div class="ttdoc">makes this book unavailable to library users </div><div class="ttdef"><b>Definition:</b> Book.cpp:61</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_1ae4179d5e953611aae20c997279e02c.html">models</a></li><li class="navelem"><a class="el" href="dir_0f93ebbc2c9bc0dc7498c103fed792b8.html">Article</a></li><li class="navelem"><a class="el" href="dir_12c7d6af7ee3b1217d99ed0e5fed6c0f.html">Book</a></li><li class="navelem"><b>Book.h</b></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
